> For the complete documentation index, see [llms.txt](https://docs.stacks.co/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.stacks.co/reference/stacks.js/stacks-transactions/types/claritytype.md).

# ClarityType

Enum representing all Clarity value type identifiers. Used for runtime type checking and serialization.

***

### Usage

```ts
import { ClarityType, isClarityType } from '@stacks/transactions';

// Type guard
if (isClarityType(value, ClarityType.UInt)) {
  console.log(value.value); // bigint
}

// Direct comparison
if (value.type === ClarityType.BoolTrue) {
  console.log('It is true');
}
```

[**Reference Link**](https://github.com/stx-labs/stacks.js/tree/main/packages/transactions/src/clarity/constants.ts)

***

### Definition

```ts
enum ClarityType {
  Int = 'int',
  UInt = 'uint',
  Buffer = 'buffer',
  BoolTrue = 'true',
  BoolFalse = 'false',
  PrincipalStandard = 'principal-standard',
  PrincipalContract = 'principal-contract',
  ResponseOk = 'ok',
  ResponseErr = 'err',
  OptionalNone = 'none',
  OptionalSome = 'some',
  List = 'list',
  Tuple = 'tuple',
  StringASCII = 'string-ascii',
  StringUTF8 = 'string-utf8',
}
```

***

### Values

| Value               | String                 | Description                                |
| ------------------- | ---------------------- | ------------------------------------------ |
| `Int`               | `'int'`                | Signed 128-bit integer                     |
| `UInt`              | `'uint'`               | Unsigned 128-bit integer                   |
| `Buffer`            | `'buffer'`             | Byte buffer                                |
| `BoolTrue`          | `'true'`               | Boolean true                               |
| `BoolFalse`         | `'false'`              | Boolean false                              |
| `PrincipalStandard` | `'principal-standard'` | Standard principal (address)               |
| `PrincipalContract` | `'principal-contract'` | Contract principal (address.contract-name) |
| `ResponseOk`        | `'ok'`                 | OK response                                |
| `ResponseErr`       | `'err'`                | Error response                             |
| `OptionalNone`      | `'none'`               | Optional none                              |
| `OptionalSome`      | `'some'`               | Optional some (wraps a value)              |
| `List`              | `'list'`               | List of values                             |
| `Tuple`             | `'tuple'`              | Tuple (key-value map)                      |
| `StringASCII`       | `'string-ascii'`       | ASCII string                               |
| `StringUTF8`        | `'string-utf8'`        | UTF-8 string                               |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.stacks.co/reference/stacks.js/stacks-transactions/types/claritytype.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
